package com.brilliance.isc.funds.fxtssb.register.settle;

import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.register.settle.common.DftcreSettleRegister;
import com.brilliance.isc.common.register.settle.common.TrtcreSettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.mda.runtime.mda.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

@Component("fxtssb.settleRegister")
public class FxtssbSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;


    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    /**
     * source:fxtssb.0010.script
     */
    private void transRegister(SetmodVo setmodVo) {
        FxdBizInfoVo rec = (FxdBizInfoVo) setmodVo.getRec();
        BigDecimal maxAmt = BigDecimal.ZERO;
        BigDecimal nom1Amt = BigDecimal.ZERO;
        if (setmodVo.getCbsMap().get("MAX") != null) {
            maxAmt = setmodVo.getCbsMap().get("MAX").getAmt();
        }
        String nom1Cur = NULLSTR;
        if (setmodVo.getCbsMap().get("NOM1") != null) {
            nom1Amt = setmodVo.getCbsMap().get("NOM1").getAmt();
            nom1Cur = setmodVo.getCbsMap().get("NOM1").getCur();
        }
        setmodVo.setDocamt(maxAmt);
        setmodVo.setOpnamt(maxAmt);
        SetglgVo setglg = setmodVo.getSetglg();
//        setmodVo.getSetglg().setglgClrAmount("TRN");
//        setmodVo.getSetglg().setglgClrAmount("SET");
        setglgService.setglgClrAmount(setglg, "TRN");
        setglgService.setglgClrAmount(setglg, "SET");
        String dsp = NULLSTR;
        String dbtKey = NULLSTR;
        String cdtKey = NULLSTR;
        if (!MdaUtils.isEmpty(nom1Amt) && !MdaUtils.isEmpty(rec.getFxtyp())) {
            if (MdaUtils.compareTo(Strings.mid(rec.getFxtyp(), 2, 1), "B") == 0) {
                if (MdaUtils.compareTo(rec.getDsp(), "CA") == 0) {
                    dsp = "LOD";
                } else {
                    dsp = rec.getDsp() + "D";
                }
                dbtKey = setglgService.setglgAddAmount(setglg, "TRN", "APL", setmodVo.getDoccur(), setmodVo.getDocamt(), "", dsp, "A", rec.getAcc(), "");
                cdtKey = setglgService.setglgAddAmount(setglg, "SET", "APL", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "SET", rec.getDsp2() + "C", "F", rec.getAcc2(), "SET");
                setglgService.setglgAddAmtFldAccCur(setglg,"SET", cdtKey, nom1Cur);
                setglgService.setglgAddAmtFldExtRat(setglg,"SET", cdtKey, BigDecimal.ONE, rec.getRat());
                setglgService.setSettlementDetails(setglg,"B", "APL", rec.getTrnman(), rec.getTrdint());
            } else {
                if (MdaUtils.compareTo(rec.getDsp(), "CA") == 0) {
                    dsp = "LOC";
                } else {
                    dsp = rec.getDsp() + "C";
                }
                cdtKey = setglgService.setglgAddAmount(setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "", dsp, "A", rec.getAcc(), "");
                dbtKey = setglgService.setglgAddAmount(setglg,"SET", "APL", setmodVo.getDoccur(), setmodVo.getSetamt(), "SET", rec.getDsp2() + "D", "F", rec.getAcc2(), "SET");
                setglgService.setglgAddAmtFldAccCur(setglg,"SET", dbtKey, nom1Cur);
                setglgService.setglgAddAmtFldExtRat(setglg,"SET", dbtKey, BigDecimal.ONE, rec.getRat());
                setglgService.setSettlementDetails(setglg,"S", "APL", rec.getTrnman(), rec.getTrdout());
            }
        }

    }
}
