package com.brilliance.isc.funds.transfer.transaction;

import com.brilliance.isc.funds.bo.funds.FxtfcmStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtlopStoreBo;
import com.brilliance.isc.funds.vo.funds.FxtfcmStoreVo;
import com.brilliance.isc.funds.vo.funds.FxtlopStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

/**
 * @program: isc-funds
 * @ClassName: FxtfcmStructMapper
 * @description:
 * @author: xiaotong
 * @create: 2024-10-11 17:17
 */
@Mapper(componentModel = "spring")
public interface FxtfcmStructMapper extends IBaseStructMapper<FxtfcmStoreBo, FxtfcmStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    FxtfcmStructMapper INSTANCE = Mappers.getMapper(FxtfcmStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    FxtfcmStoreBo voTransferToBo(FxtfcmStoreVo vo);

    /**
     * Vo追加更新至Bo
     *
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({

    })
    void voUpdateToBo(FxtfcmStoreVo vo, @MappingTarget FxtfcmStoreBo bo);

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    FxtfcmStoreVo boTransferToVo(FxtfcmStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(FxtfcmStoreBo bo, @MappingTarget FxtfcmStoreVo vo);
}
