package com.brilliance.isc.funds.transfer.transaction;

import com.brilliance.isc.funds.bo.funds.FxtsssStoreBo;
import com.brilliance.isc.funds.vo.funds.FxtsssStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

/**
 * @program: isc-funds
 * @ClassName: FxtsssStructMapper
 * @description: 即期结汇转换Fxtsss Bo、Vo之间的转换处理类。如果有很复杂的函数，则可以用适配器模式重写
 * @author: huangshunlin
 * @create: 2024-10-08 15:27
 */
@Mapper(componentModel = "spring")
public interface FxtsssStructMapper extends IBaseStructMapper<FxtsssStoreBo, FxtsssStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    FxtsssStructMapper INSTANCE = Mappers.getMapper(FxtsssStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    FxtsssStoreBo voTransferToBo(FxtsssStoreVo vo);

    /**
     * Vo追加更新至Bo
     *
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({

    })
    void voUpdateToBo(FxtsssStoreVo vo, @MappingTarget FxtsssStoreBo bo);

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    FxtsssStoreVo boTransferToVo(FxtsssStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(FxtsssStoreBo bo, @MappingTarget FxtsssStoreVo vo);
}

